## ros-galactic-webots-ros2-driver 2022.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(webots_ros2_driver)

# Check which ROS distribution is used, ros2control depends of that
if($ENV{ROS_DISTRO} MATCHES "foxy")
  add_compile_definitions(FOXY)
endif()

if($ENV{ROS_DISTRO} MATCHES "galactic")
  add_compile_definitions(GALACTIC)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Check which ROS distribution is used, vision_msgs depends of that
if($ENV{ROS_DISTRO} MATCHES "foxy")
  add_compile_definitions(FOXY)
elseif($ENV{ROS_DISTRO} MATCHES "galactic")
  add_compile_definitions(GALACTIC)
elseif($ENV{ROS_DISTRO} MATCHES "humble")
  add_compile_definitions(HUMBLE)
elseif($ENV{ROS_DISTRO} MATCHES "rolling")
  add_compile_definitions(ROLLING)
endif()

# ROS2 Packages
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rosgraph_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(pluginlib REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(vision_msgs REQUIRED)
find_package(webots_ros2_msgs REQUIRED)
find_package(tinyxml2_vendor REQUIRED)
find_package(TinyXML2 REQUIRED)

if($ENV{ROS_DISTRO} MATCHES "foxy" OR $ENV{ROS_DISTRO} MATCHES "galactic")
  find_package(PythonLibs 3.8 EXACT REQUIRED)
else()
  find_package(PythonLibs 3.10 EXACT REQUIRED)
endif()

if(UNIX AND NOT APPLE)
  set(WEBOTS_LIB_BASE webots/lib/linux-gnu)
endif()

if(APPLE)
  set(WEBOTS_LIB_BASE webots/lib/darwin19)
endif()

if(MSVC OR MSYS OR MINGW OR WIN32)
  set(WEBOTS_LIB_BASE webots/lib/msys)
endif()

include_directories(
  include
  webots/include/c
  webots/include/cpp
  ${PYTHON_INCLUDE_DIRS}
)

link_directories(${WEBOTS_LIB_BASE})

if(MSVC OR MSYS OR MINGW OR WIN32)
  # Windows requires the libController C++ part to be compiled.
  # See more here: https://cyberbotics.com/doc/guide/using-your-ide#visual-studio
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  file(GLOB CppController_SRC CONFIGURE_DEPENDS "webots/source/cpp/*.cpp")
  file(GLOB CppCarDriver_SRC CONFIGURE_DEPENDS "webots/source/cpp/vehicle/*.cpp")
  add_library(
    CppControllerRos
    SHARED
    ${CppController_SRC}
    ${CppCarDriver_SRC}
  )
  target_link_libraries(CppControllerRos
    ${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}
  )
  install(TARGETS CppControllerRos
    LIBRARY DESTINATION lib
  )
  set(WEBOTS_LIB
    ${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}
    CppControllerRos
  )
  ament_export_libraries(CppControllerRos)
else()
  set(WEBOTS_LIB
    ${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}CppController${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}CppDriver${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}
    ${CMAKE_SHARED_LIBRARY_PREFIX}CppCar${CMAKE_SHARED_LIBRARY_SUFFIX}
  )
endif()

if($ENV{ROS_DISTRO} MATCHES "foxy" OR $ENV{ROS_DISTRO} MATCHES "galactic")
  ament_python_install_package(${PROJECT_NAME}_webots
    PACKAGE_DIR ${WEBOTS_LIB_BASE}/python38)
else()
  ament_python_install_package(${PROJECT_NAME}_webots
    PACKAGE_DIR ${WEBOTS_LIB_BASE}/python310)
endif()

ament_python_install_package(${PROJECT_NAME}
  PACKAGE_DIR ${PROJECT_NAME})

add_executable(driver
  src/Driver.cpp
  src/WebotsNode.cpp
  src/PythonPlugin.cpp
  src/plugins/Ros2SensorPlugin.cpp
  src/plugins/static/Ros2Lidar.cpp
  src/plugins/static/Ros2LED.cpp
  src/plugins/static/Ros2Camera.cpp
  src/plugins/static/Ros2GPS.cpp
  src/plugins/static/Ros2RangeFinder.cpp
  src/plugins/static/Ros2DistanceSensor.cpp
  src/plugins/static/Ros2LightSensor.cpp
  src/utils/Math.cpp
  src/utils/Utils.cpp
)

# Driver
ament_target_dependencies(driver
  rosgraph_msgs
  rclcpp
  pluginlib
  sensor_msgs
  std_msgs
  tf2_geometry_msgs
  tf2_ros
  vision_msgs
  webots_ros2_msgs
  tinyxml2_vendor
  TinyXML2
)
target_link_libraries(driver
  ${WEBOTS_LIB}
  ${PYTHON_LIBRARIES}
)
install(
  DIRECTORY include/
  DESTINATION include
)
install(TARGETS driver
  RUNTIME
  DESTINATION lib/${PROJECT_NAME}
)

# Dynamic IMU
add_library(
  ${PROJECT_NAME}_imu
  SHARED
  src/plugins/dynamic/Ros2IMU.cpp
  src/plugins/Ros2SensorPlugin.cpp
  src/utils/Utils.cpp
)
ament_target_dependencies(${PROJECT_NAME}_imu
  rclcpp
  sensor_msgs
  webots_ros2_msgs
  pluginlib
  tf2_ros
)
target_link_libraries(${PROJECT_NAME}_imu
  ${WEBOTS_LIB}
)

install(
  DIRECTORY webots/include/c
  DESTINATION include/webots
)
install(
  DIRECTORY webots/include/cpp
  DESTINATION include/webots
)
install(TARGETS ${PROJECT_NAME}_imu
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

if(MSVC OR MSYS OR MINGW OR WIN32)
  # Windows requires the library to be placed with executable
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}Controller${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION lib/${PROJECT_NAME}
  )
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}car${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION lib/${PROJECT_NAME}
  )
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}driver${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION lib/${PROJECT_NAME}
  )

  # Windows requires the C++ library to be placed with the Python module
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}CppController${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}_webots/"
  )
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}CppCar${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}_webots/"
  )
  install(
    FILES "${WEBOTS_LIB_BASE}/${CMAKE_SHARED_LIBRARY_PREFIX}CppDriver${CMAKE_SHARED_LIBRARY_SUFFIX}"
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}_webots/"
  )
else()
  install(
    DIRECTORY ${WEBOTS_LIB_BASE}/
    DESTINATION lib
    PATTERN "python*" EXCLUDE
    PATTERN "*Controller*"
    PATTERN "*CppController*"
    PATTERN "*car*"
    PATTERN "*CppCar*"
    PATTERN "*driver*"
    PATTERN "*CppDriver*"
  )
endif()

# Prevent pluginlib from using boost
target_compile_definitions(driver PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_compile_definitions(${PROJECT_NAME}_imu PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
pluginlib_export_plugin_description_file(${PROJECT_NAME} webots_ros2_imu.xml)

# Install ROS 2 nodes
install(PROGRAMS ${PROJECT_NAME}/ros2_supervisor.py
  DESTINATION lib/${PROJECT_NAME}
)

# Install scripts
install(
  DIRECTORY scripts/
  DESTINATION share/${PROJECT_NAME}/scripts
)

# Ament export
ament_export_include_directories(
  include
  include/webots/c
  include/webots/cpp
)
ament_export_dependencies(
  rclcpp
  rclpy
  sensor_msgs
  std_msgs
  tf2_geometry_msgs
  tf2_ros
  vision_msgs
  webots_ros2_msgs
  tinyxml2_vendor
  TinyXML2
)
ament_export_libraries(
  ${PROJECT_NAME}_imu
  ${WEBOTS_LIB}
)
ament_package()

=== debian/changelog ===
ros-galactic-webots-ros2-driver (2022.1.4-1focal) focal; urgency=high

  * Fix the camera focal length in the CameraInfo topic.
  * Update the calculation of CameraRecognitionObject messages to the RDF convention of R2022b.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 17 Nov 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.3-1focal) focal; urgency=high

  * Added macOS support.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 01 Nov 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.2-1focal) focal; urgency=high

  * Fix issue where relatively defined PROTO were not found.
  * Added WSL support.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 20 Oct 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.1-1focal) focal; urgency=high

  * Simplified the detection of Webots installation folder.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Oct 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.0-1focal) focal; urgency=high

  * Added an URDF importer feature to spawn robots from URDF files.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 22 Sep 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.3-1focal) focal; urgency=high

  * Add option to set 'robot_description' parameter for 'robot_state_publisher' node.
  * Fix recognition camera.
  * Add a 'PointCloud2' publisher for the 'RangeFinder' device.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 29 May 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.2-1focal) focal; urgency=high

  * Fix the Supervisor API access from plugins.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 18 Jan 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.1-1focal) focal; urgency=high

  * Fix link error for 'webots_ros2_control' on macOS.
  * Fix lidar device according to FLU convention.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 09 Jan 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.0-1focal) focal; urgency=high

  * Adapt the worlds to the new R2022a FLU convention.
  * Remove a double webots_ros2_driver header installation.
  * Add the publication of the 'gps/speed_vector' topic to the GPS ROS 2 device.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 20 Dec 2021 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.1.2-1focal) focal; urgency=high

  * Adapted the 'webots_ros2_driver' package to be also a python alternative to the 'webots_ros2_core' package.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 02 Nov 2021 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.1.0-1focal) focal; urgency=high

  * Initial version

 -- Cyberbotics <support@cyberbotics.com>  Sun, 18 Jul 2021 22:00:00 -0000

=== debian/control ===
Source: ros-galactic-webots-ros2-driver
Section: misc
Priority: optional
Maintainer: Cyberbotics <support@cyberbotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-python, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-geometry-msgs, ros-galactic-pluginlib, ros-galactic-python-cmake-module, ros-galactic-rclcpp, ros-galactic-rclpy, ros-galactic-ros-environment, ros-galactic-sensor-msgs, ros-galactic-std-msgs, ros-galactic-tf2-geometry-msgs, ros-galactic-tf2-ros, ros-galactic-tinyxml2-vendor, ros-galactic-vision-msgs, ros-galactic-webots-ros2-importer, ros-galactic-webots-ros2-msgs, ros-galactic-ros-workspace
Homepage: http://wiki.ros.org/webots_ros2
Standards-Version: 3.9.2

Package: ros-galactic-webots-ros2-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-geometry-msgs, ros-galactic-pluginlib, ros-galactic-rclcpp, ros-galactic-rclpy, ros-galactic-sensor-msgs, ros-galactic-std-msgs, ros-galactic-tf2-geometry-msgs, ros-galactic-tf2-ros, ros-galactic-tinyxml2-vendor, ros-galactic-vision-msgs, ros-galactic-webots-ros2-importer, ros-galactic-webots-ros2-msgs, ros-galactic-ros-workspace
Description: Implementation of the Webots - ROS 2 interface

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-webots-ros2-driver//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
